<?php
/**
 * Checkout shipping information form
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     2.2.1
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

$checkout_fields = StaticAdqQuoteRequest::get_checkout_fields();

?>

<div class="woocommerce-shipping-fields">
        
        <?php if ( WC_Adq()->quote->needs_shipping_address() === true ) : ?>

		<?php                    
			if ( empty( $_POST ) ) {                            
				$ship_to_different_address = get_option( 'woocommerce_ship_to_destination' ) === 'shipping' ? 1 : 0;
				$ship_to_different_address = apply_filters( 'woocommerce_ship_to_different_address_checked', $ship_to_different_address );
			} else {
				$ship_to_different_address = $checkout->get_value( 'ship_to_different_address' );
			}
		?>		
		
		<h3 id="ship-to-different-address">
			<label for="ship-to-different-address-checkbox" class="checkbox"><?php _e( 'Ship to a different address?', 'woocommerce-quotation' ); ?></label>
			<input id="ship-to-different-address-checkbox" class="input-checkbox" <?php checked( $ship_to_different_address, 1 ); ?> type="checkbox" name="ship_to_different_address" value="1" />
		</h3>

		<div class="shipping_address">

			<?php do_action( 'woocommerce_before_checkout_shipping_form', $checkout ); ?>
			
			<?php foreach ( $checkout_fields['shipping'] as $key => $field ) : ?>

				<?php woocommerce_form_field( $key, $field, $checkout->get_value( $key ) ); ?>

			<?php endforeach; ?>

			<?php do_action( 'woocommerce_after_checkout_shipping_form', $checkout ); ?>

		</div>

	<?php endif; ?>

</div>
