<?php
/**
 * Customer processing order email
 *
 * @author 	Aldaba Digital
 * @package 	Woocommerce Quotation
 * @version     1.0.1
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly ?>

<?php $base_url = StaticAdqQuoteRequest::get_proposal_base_url( $order ); ?>

<?php do_action('adq_email_header', $email_heading); ?>

<p><?php _e( "Your Quote Request has been processed. Find below our proposal for your reference:", 'woocommerce-quotation' ); ?></p>

<?php if ( $order->get_user() ) : ?>

    <p><?php printf( __( 'You can access your account area to view your orders here: %s.', 'woocommerce-quotation' ), '<a href="'.get_permalink( wc_get_page_id( 'myaccount' ) ).'">'.__( 'My Account', 'woocommerce-quotation' ).'</a>' ); ?></p>

<?php endif; ?>

<p><?php printf( __( 'You can %s or %s our proposal', 'woocommerce-quotation' ), 
        '<a href="'.$base_url.'&adq_action=accept">'.__( 'Accept', 'woocommerce-quotation' ).'</a>',
        '<a href="'.$base_url.'&adq_action=reject">'.__( 'Reject', 'woocommerce-quotation' ).'</a>' ) ?></p>

<?php do_action( 'adq_email_proposal_after_header', $order, $sent_to_admin, $plain_text ); ?>

<?php do_action( 'woocommerce_email_before_order_table', $order, $sent_to_admin, $plain_text ); ?>

<h2><?php echo __( 'Our proposal:', 'woocommerce-quotation' ) . ' ' . $order->get_order_number(); ?></h2>

<table cellspacing="0" cellpadding="6" style="width: 100%; border: 1px solid #eee;" border="1" bordercolor="#eee">
	<thead>
		<tr>
			<th scope="col" style="text-align:left; border: 1px solid #eee;"><?php _e( 'Product', 'woocommerce-quotation' ); ?></th>
			<th scope="col" style="text-align:left; border: 1px solid #eee;"><?php _e( 'Quantity', 'woocommerce-quotation' ); ?></th>
			<th scope="col" style="text-align:left; border: 1px solid #eee;"><?php _e( 'Price', 'woocommerce-quotation' ); ?></th>
		</tr>
	</thead>
	<tbody>
		<?php echo adq_get_email_order_items( $order, array( 	'show_sku'    => false, 	'show_image'  => false, 	'$image_size' => array( 32, 32 ), 	'plain_text'  => false ) ); ?>
	</tbody>
	<tfoot>
		<?php
			if ( $totals = $order->get_order_item_totals() ) {
				$i = 0;
				foreach ( $totals as $total ) {
					$i++;
					?><tr>
						<th scope="row" colspan="2" style="text-align:left; border: 1px solid #eee; <?php if ( $i == 1 ) echo 'border-top-width: 4px;'; ?>"><?php echo $total['label']; ?></th>
						<td style="text-align:left; border: 1px solid #eee; <?php if ( $i == 1 ) echo 'border-top-width: 4px;'; ?>"><?php echo $total['value']; ?></td>
					</tr><?php
				}
			}
		?>
	</tfoot>
</table>

<?php do_action( 'woocommerce_email_after_order_table', $order, $sent_to_admin, $plain_text ); ?>

<?php do_action( 'woocommerce_email_customer_details', $order, $sent_to_admin, $plain_text ); ?>

<?php do_action( 'woocommerce_email_order_meta', $order, $sent_to_admin, $plain_text ); ?>

<?php do_action( 'adq_email_footer' ); ?>