<?php
/**
 * View Order
 *
 * Shows the details of a particular order on the account page
 *
 * @author    WooThemes
 * @package   WooCommerce/Templates
 * @version   2.2.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

WC_Adq()->order->order_id 	= $order_id;
$order_date					= WC_Adq()->order->get_order_date();

?>

<?php wc_print_notices(); ?>

<p class="order-info"><?php printf( __( 'Quote #<mark class="order-number">%s</mark> was placed on <mark class="order-date">%s</mark> and is currently <mark class="order-status">%s</mark>.', 'woocommerce-quotation' ), $order->get_order_number(), date_i18n( get_option( 'date_format' ), strtotime( $order_date ) ), adq_get_order_status_name( $order->get_status() ) ); ?></p>

<?php 
    $notes = $order->get_customer_order_notes();
    if ( $notes && get_option('adq_allow_order_comments_history') == "yes" ) :
	?>
	<h2><?php _e( 'Order Updates', 'woocommerce-quotation' ); ?></h2>
	<ol class="commentlist notes">
		<?php foreach ( $notes as $note ) : ?>
		<li class="comment note">                        
			<div class="comment_container">
				<div class="comment-text">                                    
                                    <p class="meta"><?php echo date_i18n( __( 'l jS \o\f F Y, h:ia', 'woocommerce-quotation' ), strtotime( $note->comment_date ) ); ?> <?php echo sprintf( __('by %s','woocommerce-quotation'), $note->comment_author)?></p>
					<div class="description">
						<?php echo wpautop( wptexturize( $note->comment_content ) ); ?>
					</div>
	  				<div class="clear"></div>
	  			</div>
				<div class="clear"></div>
			</div>
		</li>
		<?php endforeach; ?>
	</ol>
	<?php
endif;

do_action( 'woocommerce_view_order', $order_id );
